# fmt: off
# pip install Flask==2.2.2
# Set the WEBHOOK_SECRET envvar to your CTFd instance's webhook secret
import hashlib
import hmac
import os

from flask import Flask, jsonify, request

app = Flask(__name__)


@app.route('/', methods=["GET", "POST"])
def verify():
    if request.method == "GET":
        key = os.environ["WEBHOOK_SECRET"]
        token = request.args.get("token")
        response = hmac.new(
            key=key.encode(),
            msg=token.encode(),
            digestmod=hashlib.sha256
        ).hexdigest()

        return jsonify({
            "response": response,
        })
    elif request.method == "POST":
        print(request.url)
        print(request.headers)
        print(request.json)
        return "", 200


if __name__ == "__main__":
    host = os.getenv("HOST", "127.0.0.1")
    port = int(os.getenv("PORT", "12345"))
    app.run(debug=True, threaded=True, host=host, port=port)  # nosec
